--[[
Baggins_GarbageFu

Author: Mikk of Bloodhoof-EU <dpsgnome@mail.com>
Based on Baggins_Usable by: Daphne Pfister <tiiroib02@sneakemail.com>

This addon is placed in the public domain.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

]]

Baggins_GarbageFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0")

local Baggins_GarbageFu = Baggins_GarbageFu

local dewdrop = AceLibrary:HasInstance("Dewdrop-2.0") and AceLibrary("Dewdrop-2.0")

local function Matches(bag,slot,rule)
	local link = GetContainerItemLink(bag, slot)
	if(not link) then return; end
	local _,_,id = string.find(link, "item:(%d+):");
	id=tonumber(id);

	local test = rule.test
	if test == "Drop" then
		-- ChatFrame1:AddMessage("Drop " .. id .. "?  -" .. (GarbageFu:IsItemDropItem(id) and "Yes" or "No"));
		return GarbageFu:IsItemDropItem(id);
	elseif test == "Keep" then
		return GarbageFu:IsItemKeepItem(id);
	end

	return false
end

local function GetName(rule)
	local test = rule.test;
	if test == "Drop" then
		return "GarbageFu:Drop";
	elseif test == "Keep" then
		return "GarbageFu:Keep";
	end
	
	return "GarbageFu:???";
end


local function CleanRule(rule)
	rule.test = "Drop";
end


local	orig_GarbageFu_ToggleDropItem = GarbageFu.ToggleDropItem
function GarbageFu:ToggleDropItem(itemid)
	orig_GarbageFu_ToggleDropItem(GarbageFu, itemid);
	if Baggins then Baggins:ForceFullUpdate() end
end

local	orig_GarbageFu_ToggleKeepItem = GarbageFu.ToggleKeepItem
function GarbageFu:ToggleKeepItem(itemid)
	orig_GarbageFu_ToggleKeepItem(GarbageFu, itemid);
	if Baggins then Baggins:ForceFullUpdate() end
end


local function DewDropOptions(rule, level, value)
	if(level == 1) then
		dewdrop:AddLine("text", "GarbageFu Options", "isTitle", true);
		dewdrop:AddLine("text", "Manually tagged Drop", "checked", rule.test == "Drop",
			"func",function(k) rule.test = "Drop"; Baggins:OnRuleChanged() end,"arg1","Drop");
		dewdrop:AddLine("text", "Manually tagged Keep", "checked", rule.test == "Keep",
			"func",function(k) rule.test = "Keep"; Baggins:OnRuleChanged() end,"arg1","Keep");
	end
end


function Baggins_GarbageFu:OnEnable()
	Baggins:AddCustomRule("GarbageFu", {
		DisplayName = "GarbageFu",
		Description = "Filter according to GarbageFu status",
		Matches = Matches,
		GetName = GetName,
		CleanRule = CleanRule,
		DewDropOptions = DewDropOptions
	});
end

